PDF export in Angular TreeGrid component

The PDF export feature allows you to export TreeGrid data to a PDF document. To enable this functionality, set the allowPdfExport property to true. Exporting is initiated by calling the pdfExport method.

To use the PDF export functionality, you must inject the PdfExport module into the TreeGrid.

You can watch this video to learn how to perform exports and customize them in the Angular TreeGrid.

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, PdfExportService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import {ButtonModule} from '@syncfusion/ej2-angular-buttons'
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns'



import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { ToolbarItems } from '@syncfusion/ej2-treegrid';
import { PdfExportProperties } from '@syncfusion/ej2-grids';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
imports: [
        
        TreeGridModule,
        ButtonModule,
        DropDownListAllModule,
    ],

providers: [PageService,
                PdfExportService,
                ToolbarService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid [dataSource]='data' #treegrid height='220' (toolbarClick)='toolbarClick($event)' [allowPaging]='true' [allowPdfExport]='true' [pageSettings]='pager' [treeColumnIndex]='1'  childMapping='subtasks' [toolbar]='toolbarOptions'>
        <e-columns>
                    <e-column field='taskID' headerText='Task ID' textAlign='Right' width=90></e-column>
                    <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                    <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' width=120></e-column>
                    <e-column field='duration' headerText='Duration' textAlign='Right' width=110></e-column>
        </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: Object[];
    public pager?: Object;
    @ViewChild('treegrid')
    public treeGridObj?: TreeGridComponent;
    public toolbarOptions?: ToolbarItems[];

    ngOnInit(): void {
        this.data = sampleData;
        this.pager = { pageSize: 7 };
        this.toolbarOptions = ['PdfExport'];
    }
    toolbarClick(args: Object | any) : void {
        if (args['item'].text === 'PDF Export') {
            (this.treeGridObj as TreeGridComponent).pdfExport();
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Show spinner while exporting

You can show or hide a spinner component during the export process by using the showSpinner and hideSpinner methods. Use the toolbarClick event to show the spinner before exporting and the pdfExportComplete event to hide it after the export is finished.

In the following demo, the default spinner component is rendered when exporting the TreeGrid.

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, PdfExportService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import {ButtonModule} from '@syncfusion/ej2-angular-buttons'
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns'




import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { TreeGridComponent, ToolbarItems } from '@syncfusion/ej2-angular-treegrid';
import { ClickEventArgs } from '@syncfusion/ej2-angular-navigations';

@Component({
imports: [
        
        TreeGridModule,
        ButtonModule,
        DropDownListAllModule,
    ],

providers: [PageService,
                PdfExportService,
                ToolbarService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid id='TreeGrid' [dataSource]='data' height='220' (toolbarClick)='toolbarClick($event)' [allowPaging]='true' [allowPdfExport]='true' [treeColumnIndex]='1'  childMapping='subtasks' [toolbar]='toolbarOptions' (pdfExportComplete)='pdfExportComplete()'>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' width=120></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=110></e-column>
                    </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public toolbarOptions?: ToolbarItems[];
    @ViewChild('treegrid')  public treegrid?: TreeGridComponent;

    ngOnInit(): void {
        this.data = sampleData;
        this.toolbarOptions = ['PdfExport'];
    }

    toolbarClick(args: ClickEventArgs): void {
        if (args['item'].text === 'PDF Export') {
            (this.treegrid as TreeGridComponent).showSpinner();
            (this.treegrid as TreeGridComponent).pdfExport();
        }
    }

    pdfExportComplete(): void {
        (this.treegrid as TreeGridComponent).hideSpinner();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Custom data source

PDF export provides an option to define a data source dynamically before exporting. To export data dynamically, define the dataSource in exportProperties.

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, PdfExportService, ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import {ButtonModule} from '@syncfusion/ej2-angular-buttons'
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns'



import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { ToolbarItems } from '@syncfusion/ej2-treegrid';
import { PdfExportProperties, RowDataBoundEventArgs, PdfQueryCellInfoEventArgs } from '@syncfusion/ej2-grids';
import { TreeGridComponent } from '@syncfusion/ej2-angular-treegrid';

@Component({
imports: [
        
        TreeGridModule,
        ButtonModule,
        DropDownListAllModule,
    ],

providers: [PageService,
                PdfExportService,
                ToolbarService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid [dataSource]='data' #treegrid height='220' (toolbarClick)='toolbarClick($event)' [allowPaging]='true' [allowPdfExport]='true' [pageSettings]='pager' [treeColumnIndex]='1'  childMapping='subtasks' [toolbar]='toolbarOptions'>
        <e-columns>
                    <e-column field='taskID' headerText='Task ID' textAlign='Right' width=90></e-column>
                    <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                    <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' width=120></e-column>
                    <e-column field='duration' headerText='Duration' textAlign='Right' width=110></e-column>
        </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: Object[];
    public pager?: Object;
    @ViewChild('treegrid')
    public treeGridObj?: TreeGridComponent;
    public toolbarOptions?: ToolbarItems[];

    ngOnInit(): void {
        this.data = sampleData;
        this.pager = { pageSize: 7 };
        this.toolbarOptions = ['PdfExport'];
    }
    toolbarClick(args: Object| any) : void {
        if (args['item'].text === 'PDF Export') {
            let exportProperties: PdfExportProperties = {
                dataSource: sampleData,
            };
            (this.treeGridObj as TreeGridComponent).pdfExport(exportProperties);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Exporting Custom Aggregates in Tree Grid

The Tree Grid enables exporting custom aggregates, which summarize column data, to an PDFdocument using the PdfAggregateQueryCellInfo event.

In the provided example, the customAggregateFn function computes the item count for a selected category, while the PdfAggregateQueryCellInfo event customizes the exported cell values in the PDFdocument.

import { Component, OnInit, ViewChild } from '@angular/core';
import { summaryData } from './datasource';
import { getObject, PdfExportProperties } from '@syncfusion/ej2-angular-grids';
import { TreeGridComponent, TreeGridAllModule, ToolbarItems } from '@syncfusion/ej2-angular-treegrid';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { DropDownList } from '@syncfusion/ej2-angular-dropdowns';

@Component({
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid [dataSource]='dataSource' gridLines="Both" height='350' childMapping='subtasks' [allowPdfExport]='true' [toolbar]='toolbarOptions' (toolbarClick)='toolbarClick($event)' [treeColumnIndex]='1' (dataBound)='onDataBound($event)' (pdfAggregateQueryCellInfo)="pdfAggregateQueryCellInfo($event)">
      <e-columns>
          <e-column field='ID' headerText='Order ID' width='120' textAlign='Left'></e-column>
          <e-column field='Name' headerText='Shipment Name' textAlign="Left" clipMode='EllipsisWithTooltip' width='230' ></e-column>
          <e-column field='shipmentDate' headerText='Shipment Date' width="120" type="date" format="yMd" textAlign="Right"></e-column>
          <e-column field='category' headerText='Category' width='200' minWidth='240' textAlign="Left" ></e-column>
          <e-column field='units' headerText='Units' width='80' type='number' textAlign="Right"  ></e-column>
          <e-column field='unitPrice' headerText='Unit Price($)' width='120'  type='number' textAlign="Right" format='C2' ></e-column>
          <e-column field='price' headerText='Price($)' width='110' type='number' format='C0'  textAlign="Right" ></e-column>
      </e-columns>
      <e-aggregates >
              <e-aggregate [showChildSummary]='false'>
                  <e-columns >
                      <e-column columnName="category" type="Custom" [customAggregate]="customAggregateFn">
                          <ng-template #footerTemplate  let-data>
                             <span>Count of <input type="text" id="customers" /> : </span>
                           </ng-template>
                      </e-column>
                  </e-columns>
              </e-aggregate>
          </e-aggregates>
  </ejs-treegrid>`,
    standalone: true,
    imports: [TreeGridAllModule],
})
export class AppComponent {
    public dataSource: Object[] = [];
    public foods: any;
    public selectedCategory: string = 'Seafood';
    public listObj!: DropDownList;
    public toolbarOptions?: ToolbarItems[];
    public customAggregateFn!: (data: Object) => number;
    public countLength: number = 0;
    public stringAlign: string = 'Left';
    public numberAlign: string = 'Right';
    @ViewChild('treegrid')
    public treegrid!: TreeGridComponent;
    ngOnInit(): void {
        this.dataSource = summaryData;
        this.foods = [
            { food: 'Seafood' },
            { food: 'Dairy' },
            { food: 'Edible' },
            { food: 'Crystal' },
        ];
        this.toolbarOptions = ['PdfExport'];
        this.customAggregateFn = this.createCustomAggregateFn(
            this.selectedCategory
        );
    }

    //Custom aggregate function to calculate the count of items for the selected category.
    private createCustomAggregateFn(
        selectedValue: string
    ): (data: Object) => number {
        return (data: Object): number => {
            const sampleDatas: any = getObject('result', data) ?? data;
            return sampleDatas
                ? sampleDatas.filter(
                    (item: Object) => getObject('category', item) === selectedValue
                ).length
                : 0;
        };
    }

    //Handles the 'pdfAggregateQueryCellInfo' event to customize aggregate cells during PDF export.
    public pdfAggregateQueryCellInfo = (args: any): void => {
        if (args.cell.column.headerText === 'Category') {
            args.value =
                'Count of ' +
                this.selectedCategory +
                ' : ' +
                args.row.data.category.Custom;
        }
    };

    //Initializes a DropDownList in the footer for category selection.
    onDataBound(args: any): void {
        if (!isNullOrUndefined(this.listObj)) {
            this.listObj.destroy();
        }
        var proxy = this;
        this.listObj = new DropDownList({
            dataSource: proxy.foods,
            fields: { value: 'food' },
            placeholder: 'Select a Category',
            width: '110px',
            value: this.selectedCategory,
            change: () => {
                setTimeout(() => {
                    this.selectedCategory = (this.listObj as any).value.toString();
                    proxy.selectedCategory = this.selectedCategory;
                    proxy.customAggregateFn = proxy.createCustomAggregateFn(
                        proxy.selectedCategory
                    );
                    proxy.treegrid.refresh();
                }, 300);
            },
        });
        this.listObj.appendTo('#customers');
    }
    toolbarClick(args: Object | any): void {
        if (args['item'].text === 'PDF Export') {
            let exportProperties: PdfExportProperties = {
                pageOrientation: 'Landscape',
            };
            this.treegrid?.pdfExport(exportProperties);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can refer to our Angular TreeGrid feature tour page for its groundbreaking feature representations. You can also explore our Angular TreeGrid example to learn how to present and manipulate data.

PDF export in React TreeGrid

PDF export enables exporting TreeGrid data to a PDF document. Export by calling the pdfExport method. To enable PDF export in the TreeGrid, set allowPdfExport to true.

For a quick start with exporting functionalities, refer to this video:

import { ColumnDirective, ColumnsDirective, Page, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';
function App() {
    const toolbarOptions = ['PdfExport'];
    const pageSettings = { pageSize: 7 };
    let treegrid;
    const toolbarClick = (args) => {
        if (treegrid && args.item.text === 'PDF Export') {
            treegrid.pdfExport();
        }
    };
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks' allowPaging={true} pageSettings={pageSettings} allowPdfExport={true} height='220' toolbarClick={toolbarClick} ref={g => treegrid = g} toolbar={toolbarOptions}>
        <ColumnsDirective>
            <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right'/>
            <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
            <ColumnDirective field='startDate' headerText='Start Date' width='90' format='yMd' textAlign='Right' type='date'/>
            <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right'/>
        </ColumnsDirective>
        <Inject services={[Page, Toolbar, PdfExport]}/>
    </TreeGridComponent>;
}
;
export default App;
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, Page, PageSettingsModel, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar, ToolbarItems, TreeGrid } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';

function App() {
    const toolbarOptions: ToolbarItems[] = ['PdfExport'];
    const pageSettings: PageSettingsModel = { pageSize: 7 };
    let treegrid: TreeGridComponent | null;

    const toolbarClick = (args: ClickEventArgs): void => {
        if (treegrid && args.item.text === 'PDF Export') {
            treegrid.pdfExport();
        }
    }
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'
    allowPaging={true} pageSettings={pageSettings} allowPdfExport={true} height='220'
    toolbarClick={toolbarClick} ref={g => treegrid = g} toolbar={toolbarOptions}>
        <ColumnsDirective>
            <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right'/>
            <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
            <ColumnDirective field='startDate' headerText='Start Date' width='90' format='yMd' textAlign='Right' type='date' />
            <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right' />
        </ColumnsDirective>
        <Inject services={[Page, Toolbar, PdfExport]}/>
    </TreeGridComponent>
};
export default App;

Custom data source

PDF export supports defining a datasource dynamically before exporting. To export data dynamically, set the dataSource in PdfExportProperties.

import { ColumnDirective, ColumnsDirective, Page, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';
function App() {
    const toolbarOptions = ['PdfExport'];
    const pageSettings = { pageSize: 7 };
    let treegrid;
    const toolbarClick = (args) => {
        if (treegrid) {
            const exportProperties = {
                dataSource: sampleData,
            };
            treegrid.pdfExport(exportProperties);
        }
    };
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks' allowPaging={true} pageSettings={pageSettings} allowPdfExport={true} height='220' toolbarClick={toolbarClick} ref={g => treegrid = g} toolbar={toolbarOptions}>
        <ColumnsDirective>
            <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right'/>
            <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
            <ColumnDirective field='startDate' headerText='Start Date' width='90' format='yMd' textAlign='Right' type='date'/>
            <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right'/>
        </ColumnsDirective>
        <Inject services={[Page, Toolbar, PdfExport]}/>
    </TreeGridComponent>;
}
;
export default App;
import { PdfExportProperties } from '@syncfusion/ej2-grids';
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, Page, PageSettingsModel, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar, ToolbarItems, TreeGrid } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';

function App() {
    const toolbarOptions: ToolbarItems[] = ['PdfExport'];
    const pageSettings: PageSettingsModel = { pageSize: 7 };
    let treegrid: TreeGridComponent | null;

    const toolbarClick = (args: ClickEventArgs): void => {
        if (treegrid) {
            const exportProperties: PdfExportProperties = {
                 dataSource: sampleData,
            };
            treegrid.pdfExport(exportProperties);
        }
    }
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'
    allowPaging={true} pageSettings={pageSettings} allowPdfExport={true} height='220'
    toolbarClick={toolbarClick} ref={g => treegrid = g} toolbar={toolbarOptions}>
        <ColumnsDirective>
            <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right'/>
            <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
            <ColumnDirective field='startDate' headerText='Start Date' width='90' format='yMd' textAlign='Right' type='date' />
            <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right' />
        </ColumnsDirective>
        <Inject services={[Page, Toolbar, PdfExport]}/>
    </TreeGridComponent>
};
export default App;

Exporting Custom Aggregates in TreeGrid

The TreeGrid supports exporting custom aggregates, which summarize column data, to a PDF document using the PdfAggregateQueryCellInfo event.

In the example, the customAggregateFn function computes the item count for a selected category, and the PdfAggregateQueryCellInfo event customizes the exported cell values in the PDF document.

import { getObject, PdfExportProperties } from '@syncfusion/ej2-grids';
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, AggregatesDirective,AggregateColumnsDirective,AggregateColumnDirective, AggregateDirective, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar, Aggregate, ToolbarItems, TreeGrid } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { summaryData } from './datasource';
import { DropDownList } from '@syncfusion/ej2-react-dropdowns';
import { isNullOrUndefined } from '@syncfusion/ej2-base';

function App() {
     let item = "Seafood";
    const toolbarOptions = ['PdfExport'];
    let treegrid;

     const toolbarClick = (args) => {
          if (treegrid && args.item.text === 'Excel Export') {
              (treegrid).excelExport();
          }
          else if (treegrid && args.item.text === 'PDF Export') {
              let exportProperties = {
            pageOrientation: 'Landscape',
        };
              (treegrid).pdfExport(exportProperties);
          }
          else if (treegrid && args.item.text === 'CSV Export') {
              (treegrid).csvExport();
          }
      }
  
    //Handles the 'pdfAggregateQueryCellInfo' event to customize aggregate cells during PDF export.
    const pdfAggregateQueryCellInfo = (args) => {
        if (args.cell.column.headerText === "Category") {
            args.value = "Count of " + item + " : " + args.row.data.category.Custom;
        }
    }
    let listObj;
    const foods = [
        { food: "Seafood" },
        { food: "Dairy" },
        { food: "Edible" },
        { food: "Crystal" },
    ];

    //Custom aggregate function to calculate the count of items for the selected category.
    const customAggregateFn = (data) => {
        let sampleData = data.result ? getObject('result', data) : data;

        let countLength;
        countLength = 0;
        if (sampleData !== undefined) {
            sampleData.filter((record) => {
                let data = getObject("category", record);
                let value = item;
                if (data === value) {
                    countLength++;
                }
            });
        }
        return countLength;
    };
    const custom = (props) => {
        return (
            <span>
                {" "}
                Count of <input type="text" id="customers" /> : {props.Custom}
            </span>
        );
    };
    const dataBound = () => {
        setTimeout(() => {
            if (!isNullOrUndefined(listObj)) {
                listObj.destroy();
            }
            listObj = new DropDownList({
                dataSource: foods,
                fields: { value: "food" },
                placeholder: "Select a Category",
                width: "110px",
                value: item,
                change: () => {
                    setTimeout(() => {
                        item = (listObj as any).value.toString();
                        treegrid.refresh();
                    }, 300);
                },
            });
            listObj.appendTo("#customers");
        })
    };
    return <TreeGridComponent
        dataSource={summaryData} treeColumnIndex={1} childMapping="subtasks"
        height="400" ref={(g) => treegrid = g} allowPdfExport={true} dataBound={dataBound}
        pdfAggregateQueryCellInfo={pdfAggregateQueryCellInfo} toolbarClick={toolbarClick}
        toolbar={toolbarOptions}
    >
        <ColumnsDirective>
            <ColumnDirective field='ID' headerText='Order ID' width='115' textAlign='Left'></ColumnDirective>
            <ColumnDirective field='Name' headerText='Shipment Name' textAlign='Left' width='230'></ColumnDirective>
            <ColumnDirective field='shipmentDate' headerText='Shipment Date' width='135' textAlign='Right' type='date' format='yMd'></ColumnDirective>
            <ColumnDirective field='category' headerText='Category' width='220' textAlign='Left' minWidth='220' />
            <ColumnDirective field='units' headerText='Units' width='90' textAlign='Right' type='number' />
            <ColumnDirective field='unitPrice' headerText='Unit Price($)' width='100' textAlign='Right' type='number' format='C2' />
            <ColumnDirective field='price' headerText='Price($)' width='100' textAlign='Right' type='number' format='C0' />
        </ColumnsDirective>
        <AggregatesDirective>
            <AggregateDirective showChildSummary={false}>
                <AggregateColumnsDirective>
                    <AggregateColumnDirective
                        columnName="category"
                        type="Custom"
                        customAggregate={customAggregateFn}
                        footerTemplate={custom}
                    >
                        {" "}
                    </AggregateColumnDirective>
                </AggregateColumnsDirective>
            </AggregateDirective>
        </AggregatesDirective>
        <Inject services={[Aggregate, Toolbar, PdfExport]} />
    </TreeGridComponent>
};
export default App;
import { getObject, PdfExportProperties } from '@syncfusion/ej2-grids';
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, AggregatesDirective,AggregateColumnsDirective,AggregateColumnDirective, AggregateDirective, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Inject, PdfExport, Toolbar, Aggregate, ToolbarItems, TreeGrid } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { summaryData } from './datasource';
import { DropDownList } from '@syncfusion/ej2-react-dropdowns';
import { isNullOrUndefined } from '@syncfusion/ej2-base';

function App() {
     let item: string = "Seafood";
    const toolbarOptions: ToolbarItems[] = ['PdfExport'];
    let treegrid: TreeGridComponent;

     const toolbarClick = (args: ClickEventArgs): void => {
          if (treegrid && args.item.text === 'Excel Export') {
              (treegrid as any).excelExport();
          }
          else if (treegrid && args.item.text === 'PDF Export') {
              let exportProperties: PdfExportProperties = {
            pageOrientation: 'Landscape',
        };
              (treegrid as any).pdfExport(exportProperties);
          }
          else if (treegrid && args.item.text === 'CSV Export') {
              (treegrid as any).csvExport();
          }
      }
  
    //Handles the 'pdfAggregateQueryCellInfo' event to customize aggregate cells during PDF export.
    const pdfAggregateQueryCellInfo = (args: any): void => {
        if (args.cell.column.headerText === "Category") {
            args.value = "Count of " + item + " : " + args.row.data.category.Custom;
        }
    }
    let listObj: DropDownList;
    const foods: { [key: string]: Object }[] = [
        { food: "Seafood" },
        { food: "Dairy" },
        { food: "Edible" },
        { food: "Crystal" },
    ];

    //Custom aggregate function to calculate the count of items for the selected category.
    const customAggregateFn = (data: any): any => {
        let sampleData: any = data.result ? getObject('result', data) : data;

        let countLength: number;
        countLength = 0;
        if (sampleData !== undefined) {
            sampleData.filter((record: Object) => {
                let data: string = getObject("category", record);
                let value: string = item;
                if (data === value) {
                    countLength++;
                }
            });
        }
        return countLength;
    };
    const custom = (props:any): any => {
        return (
            <span>
                {" "}
                Count of <input type="text" id="customers" /> : {props.Custom}
            </span>
        );
    };
    const dataBound = (): void => {
        setTimeout(() => {
            if (!isNullOrUndefined(listObj)) {
                listObj.destroy();
            }
            listObj = new DropDownList({
                dataSource: foods,
                fields: { value: "food" },
                placeholder: "Select a Category",
                width: "110px",
                value: item,
                change: () => {
                    setTimeout(() => {
                        item = (listObj as any).value.toString();
                        treegrid.refresh();
                    }, 300);
                },
            });
            listObj.appendTo("#customers");
        })
    };
    return <TreeGridComponent
        dataSource={summaryData} treeColumnIndex={1} childMapping="subtasks"
        height="400" ref={(g:any) => treegrid = g} allowPdfExport={true} dataBound={dataBound}
        pdfAggregateQueryCellInfo={pdfAggregateQueryCellInfo} toolbarClick={toolbarClick}
        toolbar={toolbarOptions}
    >
        <ColumnsDirective>
            <ColumnDirective field='ID' headerText='Order ID' width='115' textAlign='Left'></ColumnDirective>
            <ColumnDirective field='Name' headerText='Shipment Name' textAlign='Left' width='230'></ColumnDirective>
            <ColumnDirective field='shipmentDate' headerText='Shipment Date' width='135' textAlign='Right' type='date' format='yMd'></ColumnDirective>
            <ColumnDirective field='category' headerText='Category' width='220' textAlign='Left' minWidth='220' />
            <ColumnDirective field='units' headerText='Units' width='90' textAlign='Right' type='number' />
            <ColumnDirective field='unitPrice' headerText='Unit Price($)' width='100' textAlign='Right' type='number' format='C2' />
            <ColumnDirective field='price' headerText='Price($)' width='100' textAlign='Right' type='number' format='C0' />
        </ColumnsDirective>
        <AggregatesDirective>
            <AggregateDirective showChildSummary={false}>
                <AggregateColumnsDirective>
                    <AggregateColumnDirective
                        columnName="category"
                        type="Custom"
                        customAggregate={customAggregateFn}
                        footerTemplate={custom}
                    >
                        {" "}
                    </AggregateColumnDirective>
                </AggregateColumnsDirective>
            </AggregateDirective>
        </AggregatesDirective>
        <Inject services={[Aggregate, Toolbar, PdfExport]} />
    </TreeGridComponent>
};
export default App;

Refer to the React TreeGrid feature tour page for highlights. Explore the React TreeGrid example to learn how to present and manipulate data.

PDF export in Vue Treegrid component

PDF export allows exporting TreeGrid data to PDF document. You need to use the pdfExport method for exporting. To enable PDF export in the treegrid, set the allowPdfExport as true.

To use PDF export, inject the PdfExport module in treegrid.

To get start quickly with PDF export feature, you can check on this video:

<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' height='220' childMapping='subtasks' :treeColumnIndex='1' :allowPaging='true' :pageSettings='pageSettings' :allowPdfExport='true' :toolbar='toolbarOptions' :toolbarClick='toolbarClick'>
            <e-columns>
                <e-column field='taskID' headerText='Task ID' width='90' textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width='160'></e-column>
                <e-column field='startDate' headerText='Start Date' width='90' format="yMd" textAlign='Right'></e-column>
                <e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
            </e-columns>
        </ejs-treegrid>
</div>
</template>
<script setup>
import { provide, ref } from "vue";

import { TreeGridComponent as EjsTreegrid, Page, Toolbar, PdfExport, ColumnDirective as EColumn, ColumnsDirective as EColumns } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

const treegrid = ref(null);

const data = sampleData;

const toolbarOptions = ['PdfExport'];

const pageSettings = { pageSize: 7 };

const toolbarClick = function(args) {
    if (args['item'].text === 'PDF Export') {
        treegrid.value.pdfExport();
    }
};

provide('treegrid',  [ Page, Toolbar, PdfExport ]);

</script>
<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' height='220' childMapping='subtasks' :treeColumnIndex='1' :allowPaging='true' :pageSettings='pageSettings' :allowPdfExport='true' :toolbar='toolbarOptions' :toolbarClick='toolbarClick'>
            <e-columns>
                <e-column field='taskID' headerText='Task ID' width='90' textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width='160'></e-column>
                <e-column field='startDate' headerText='Start Date' width='90' format="yMd" textAlign='Right'></e-column>
                <e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
            </e-columns>
        </ejs-treegrid>
</div>
</template>
<script>

import { TreeGridComponent, Page, Toolbar, PdfExport, ColumnDirective, ColumnsDirective } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

export default {
name: "App",
components: {
"ejs-treegrid":TreeGridComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective,

},

  data ()  {
    return {
      data: sampleData,
      toolbarOptions: ['PdfExport'],
      pageSettings: { pageSize: 7 }
    };
  },
  methods: {
      toolbarClick(args) {
        if (args['item'].text === 'PDF Export') {
            this.$refs.treegrid.pdfExport();
        }
    }
  },
  provide: {
      treegrid: [ Page, Toolbar, PdfExport ]
  }
}
</script>

Custom data source

PDF export provides an option to define datasource dynamically before exporting. To export data dynamically, define the dataSource in exportProperties.

<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' height='220' childMapping='subtasks' :treeColumnIndex='1' :allowPaging='true' :pageSettings='pageSettings' :allowPdfExport='true' :toolbar='toolbarOptions' :toolbarClick='toolbarClick'>
            <e-columns>
                <e-column field='taskID' headerText='Task ID' width='90' textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width='160'></e-column>
                <e-column field='startDate' headerText='Start Date' width='90' format="yMd" textAlign='Right'></e-column>
                <e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
            </e-columns>
        </ejs-treegrid>
</div>
</template>
<script setup>
import { provide, ref } from "vue";

import { TreeGridComponent as EjsTreegrid, Page, Toolbar, PdfExport,
  ColumnDirective as EColumn, ColumnsDirective as EColumns
 } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

const treegrid = ref(null);

const data = sampleData;
const toolbarOptions = ['PDfExport'];

const pageSettings = { pageSize: 7 };

const toolbarClick = (args) => {
        if (args['item'].text === 'PDF Export') {
          let pdfExportProperties = {
            dataSource: sampleData,
          }
          treegrid.value.pdfExport(pdfExportProperties);
        }
};
provide('treegrid',  [ Page, Toolbar, PdfExport ]);

</script>
<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' height='220' childMapping='subtasks' :treeColumnIndex='1' :allowPaging='true' :pageSettings='pageSettings' :allowPdfExport='true' :toolbar='toolbarOptions' :toolbarClick='toolbarClick'>
            <e-columns>
                <e-column field='taskID' headerText='Task ID' width='90' textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width='160'></e-column>
                <e-column field='startDate' headerText='Start Date' width='90' format="yMd" textAlign='Right'></e-column>
                <e-column field='duration' headerText='Duration' width='80' textAlign='Right'></e-column>
            </e-columns>
        </ejs-treegrid>
</div>
</template>
<script>

import { TreeGridComponent, Page, Toolbar, PdfExport, ColumnDirective, ColumnsDirective } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

export default {
name: "App",
components: {
"ejs-treegrid":TreeGridComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective,

},

  data ()  {
    return {
      data: sampleData,
      toolbarOptions: ['PdfExport'],
      pageSettings: { pageSize: 7 }
    };
  },
  methods: {
      toolbarClick(args) {
        if (args['item'].text === 'PDF Export') {
          let pdfExportProperties = {
            dataSource: sampleData,
          }
          this.$refs.treegrid.pdfExport(pdfExportProperties);
        }
      }
  },
  provide: {
      treegrid: [ Page, Toolbar, PdfExport ]
  }
}
</script>

Exporting Custom Aggregates in Tree Grid

The Tree Grid enables exporting custom aggregates, which summarize column data, to an PDF document using the PdfAggregateQueryCellInfo event.

In the provided example, the customAggregateFn function computes the item count for a selected category, while the PdfAggregateQueryCellInfo event customizes the exported cell values in the PDF document.

```vue
<template>
  <div class="col-lg-12 control-section">
    <div>
      <ejs-treegrid
        :dataSource="data"
        ref="treegrid"
        childMapping="subtasks"
        gridLines="Both"
        :treeColumnIndex="1"
        :allowPdfExport="true"
        :dataBound="dataBound"
        :toolbar="toolbarOptions"
        :toolbarClick="toolbarClick"
        :pdfAggregateQueryCellInfo="pdfAggregateQueryCellInfo"
        :height="380"
      >
        <e-columns>
          <e-column field="ID" headerText="Order ID" width="120" textAlign="Left"></e-column>
          <e-column field="Name" headerText="Shipment Name" width="230" clipMode="EllipsisWithTooltip"></e-column>
          <e-column field="shipmentDate" headerText="Shipment Date" width="150" type="date" format="yMd" textAlign="Right"></e-column>
          <e-column field="category" headerText="Category" width="220" minWidth="220"></e-column>
          <e-column field="units" headerText="Units" width="100" textAlign="Right" type="number"></e-column>
          <e-column field="unitPrice" headerText="Unit Price($)" format="c2" width="100" textAlign="Right" type="number"></e-column>
          <e-column field="price" headerText="Price($)" width="140" format="c" textAlign="Right"></e-column>
        </e-columns>
        <e-aggregates>
          <e-aggregate :showChildSummary="false">
            <e-columns>
              <e-column columnName="category" type="Custom" :customAggregate="customAggregateFn" :footerTemplate="footerTemplate"></e-column>
            </e-columns>
          </e-aggregate>
        </e-aggregates>
      </ejs-treegrid>
    </div>
  </div>
</template>

<script setup>
import { ref, h } from "vue";
import { TreeGridComponent, ColumnDirective, ColumnsDirective, AggregateDirective, AggregatesDirective, Aggregate, Page, Toolbar, PdfExport } from "@syncfusion/ej2-vue-treegrid";
import { DropDownList } from "@syncfusion/ej2-dropdowns";
import { summaryData } from "./datasource";
import { getObject, isNullOrUndefined } from "@syncfusion/ej2-base";

// Reactive state
const data = ref(summaryData);
const selectedCategory = ref("Seafood");
const toolbarOptions = ref(["PdfExport"]);
const treegrid = ref(null);

const foods = [
  { food: "Seafood" },
  { food: "Dairy" },
  { food: "Edible" },
  { food: "Crystal" }
];

// Footer template
const FooterTemplate = () => {
  return h("span", {}, [
    "Count of ",
    h("input", { type: "text", id: "customers" }),
    `: ${selectedCategory.value}`
  ]);
};

const footerTemplate = FooterTemplate;

// Custom aggregate function
const customAggregateFn = (data) => {
  const sampleData = data.result ? getObject("result", data) : data;
  let countLength = 0;

  if (sampleData !== undefined) {
    sampleData.forEach((item) => {
      const category = getObject("category", item);
      if (category === selectedCategory.value) {
        countLength++;
      }
    });
  }
  return countLength;
};

// Initialize DropDownList in the footer
let listObj = null;
const dataBound = () => {
  const treeGridObj = treegrid.value;
  if (!isNullOrUndefined(listObj)) {
    listObj.destroy();
  }
  listObj = new DropDownList({
    dataSource: foods,
    fields: { value: "food" },
    placeholder: "Select a Category",
    width: "110px",
    value: selectedCategory.value,
    change: () => {
      setTimeout(() => {
        if (listObj.value != null) {
          selectedCategory.value = listObj.value.toString();
          treeGridObj.refresh();
        }
      }, 300);
    }
  });
  listObj.appendTo("#customers");
};

// Toolbar click handler
const toolbarClick = (args) => {
  const treeGridObj = treegrid.value;
  if (args.item.text === "PDF Export") {
    const exportProperties = {
      pageOrientation: "Landscape"
    };
    treeGridObj.pdfExport(exportProperties);
  }
};

// PDF aggregate query cell info handler
const pdfAggregateQueryCellInfo = (args) => {
  if (args.cell.column.headerText === "Category") {
    args.value = `Count of ${selectedCategory.value}: ${args.row.data.category.Custom}`;
  }
};

// Provide dependencies
provide("treegrid", [Aggregate, Page, Toolbar, PdfExport]);
</script>
```
<template>
  <div class="col-lg-12 control-section">
    <div>
      <ejs-treegrid
        :dataSource="data"
        ref="treegrid"
        childMapping="subtasks"
        gridLines="Both"
        :treeColumnIndex="1"
        :allowPdfExport="true"
        :dataBound="dataBound"
        :toolbar="toolbarOptions"
        :toolbarClick="toolbarClick"
        :pdfAggregateQueryCellInfo="pdfAggregateQueryCellInfo"
        :height="380"
      >
        <e-columns>
          <e-column
            field="ID"
            headerText="Order ID"
            width="120"
            textAlign="Left"
          ></e-column>
          <e-column
            field="Name"
            headerText="Shipment Name"
            width="230"
            clipMode="EllipsisWithTooltip"
          ></e-column>
          <e-column
            field="shipmentDate"
            headerText="Shipment Date"
            width="150"
            type="date"
            format="yMd"
            textAlign="Right"
          ></e-column>
          <e-column
            field="category"
            headerText="Category"
            width="220"
            minWidth="220"
          ></e-column>
          <e-column
            field="units"
            headerText="Units"
            width="100"
            textAlign="Right"
            type="number"
          ></e-column>
          <e-column
            field="unitPrice"
            headerText="Unit Price($)"
            format="c2"
            width="100"
            textAlign="Right"
            type="number"
          ></e-column>
          <e-column
            field="price"
            headerText="Price($)"
            width="140"
            format="c"
            textAlign="Right"
          ></e-column>
        </e-columns>
        <e-aggregates>
          <e-aggregate :showChildSummary="false">
            <e-columns>
              <e-column
                columnName="category"
                type="Custom"
                :customAggregate="customAggregateFn"
                :footerTemplate="footerTemp"
              ></e-column>
            </e-columns>
          </e-aggregate>
        </e-aggregates>
      </ejs-treegrid>
    </div>
  </div>
</template>
<!-- custom code start -->
<style>
T .e-input {
  padding-bottom: 1px !important;
}
.e-treegrid .e-summarycell.e-templatecell {
  pointer-events: visible !important;
}
.fluent2 input#customers {
  padding-bottom: 8px !important;
}
.bootstrap5\.3 input#customers {
  padding-bottom: 7px !important;
}
.tailwind3 input#customers {
  padding-bottom: 1px !important;
}
.e-treegrid .e-summarycell.e-templatecell .e-input-group {
  padding-left: 6px !important;
}
</style>
<!-- custom code end -->
<script lang="ts">
import { createApp } from "vue";
import {
  TreeGridComponent,
  ColumnDirective,
  ColumnsDirective,
  AggregateDirective,
  AggregatesDirective,
  Aggregate,
  Page,
  Toolbar,
  PdfExport,
} from "@syncfusion/ej2-vue-treegrid";
import { summaryData } from "./datasource";
import {
  DropDownList,
  DropDownListComponent,
} from "@syncfusion/ej2-vue-dropdowns";
import { getObject, CustomSummaryType } from "@syncfusion/ej2-grids";
import { isNullOrUndefined } from "@syncfusion/ej2-base";

let listObj: DropDownList;
let selectedCategory: string = "Seafood";
let foods = [
  { food: "Seafood" },
  { food: "Dairy" },
  { food: "Edible" },
  { food: "Crystal" },
];

export default {
  components: {
    "ejs-treegrid": TreeGridComponent,
    "e-column": ColumnDirective,
    "e-columns": ColumnsDirective,
    "e-aggregates": AggregatesDirective,
    "e-aggregate": AggregateDirective,
    "ejs-dropdownlist": DropDownListComponent,
  },
  data: () => {
    return {
      data: summaryData,
      selectedCategory: "Seafood",
      toolbarOptions: ["PdfExport"],
      footerTemp: function () {
        return {
          template: createApp({}).component("footerTemplate", {
            template: `<span>Count of <input type="text" id="customers" /> : </span>`,
            data() {
              return { data: {} };
            },
          }),
        };
      },
    };
  },
  provide: {
    treegrid: [Aggregate, Page, Toolbar, PdfExport],
  },
  methods: {
    //Custom aggregate function to calculate the count of items for the selected category.
    customAggregateFn: function (data: any) {
      (this as any).$refs.treegrid.ej2Instances.grid.vueInstance = null;
      let sampleData: any = data.result ? getObject("result", data) : data;

      let countLength: number;
      countLength = 0;
      if (sampleData !== undefined) {
        sampleData.filter((item: Object) => {
          let data: string = getObject("category", item);
          if (data === selectedCategory) {
            countLength++;
          }
        });
      }
      return countLength;
    },

    //Initializes a DropDownList in the footer for category selection.
    dataBound: function () {
      let treeGridObj = (this as any).$refs.treegrid;
      if (!isNullOrUndefined(listObj)) {
        listObj.destroy();
      }
      listObj = new DropDownList({
        dataSource: foods,
        fields: { value: "food" },
        placeholder: "Select a Category",
        width: "110px",
        value: selectedCategory,
        change: function () {
          setTimeout(function () {
            if (listObj.value != null) {
              selectedCategory = listObj.value.toString();
              treeGridObj.refresh();
            }
          }, 300);
        },
      });
      listObj.appendTo("#customers");
    },
    toolbarClick: function (args: any) {
      let treeGridObj = (this as any).$refs.treegrid;
      if (args["item"].text === "PDF Export") {
        let exportProperties: any = {
          pageOrientation: "Landscape",
        };
        treeGridObj.pdfExport(exportProperties);
      }
    },

    //Handles the 'pdfAggregateQueryCellInfo' event to customize aggregate cells during PDF export.
    pdfAggregateQueryCellInfo(args: any) {
      if (args.cell.column.headerText === "Category") {
        args.value = `Count of ${selectedCategory}: ${args.row.data.category.Custom}`;
      }
    },
  },
};
</script>